#include <sourcemod>
#include <sdktools>
#include <sdkhooks>
#include <multicolors>
#include <autoexecconfig>
#include <cstrike>
#include <adminmenu>

/////////////////////////////////////////////////////////////////////////////////////////////////
// Credits for:
// Simple Weapon Restrictor - https://forums.alliedmods.net/showthread.php?p=2429066 - By N1ckles
//
// Dependencies are Required:
// Anti Deagle Spam - https://github.com/Xurape/Anti-Deagle-Spray by SHUT UP
// Deagle HS Only - https://forums.alliedmods.net/showthread.php?t=331188 by Spirt
/////////////////////////////////////////////////////////////////////////////////////////////////


public Plugin myinfo = 
{
	name = "Deagle Modes", 
	author = "LanteJoula", 
	description = "Deagle Modes - Admin Deagle Modes and Votes Deagle Modes", 
	version = "1.6", 
	url = "https://steamcommunity.com/id/lantejoula/"
};

#define DEBUG

#pragma semicolon 1

#pragma newdecls required

//Bool

bool OnlyHeadShot = true;
bool AntiSpam = true;
bool Deagle1 = true;

//ConVars

char g_ChatPrefix[256];
ConVar gConVar_Chat_Prefix;

ConVar gConVar_DisableDeagle_Message;
ConVar gConVar_EnableDeagle_Message;
ConVar gConVar_OnOnlyHeadShot_Message;
ConVar gConVar_OffOnlyHeadShot_Message;
ConVar gConVar_OnAntiSpam_Message;
ConVar gConVar_OffAntiSpam_Message;

ConVar gConVar_Start_Vote_Message;
ConVar gConVar_Votes_Resultes_Message;

ConVar gConVar_MapChange;

ConVar gConVar_CoolDown;

ConVar gConVar_JoinMsg;
ConVar gConVar_JoinStaffMsg;

//Disable Deagle

#define NAME_LENGTH 64

ArrayList g_alRestrictedWeapons = null;

bool g_bLateLoaded = false;

//ADMIN MENU

Handle hAdminMenu;

public APLRes AskPluginLoad2(Handle myself, bool late, char[] error, int err_max)
{
	g_bLateLoaded = late;
}

public void OnPluginStart()
{
	//Translations
	LoadTranslations("deaglemodes.phrases");
	
	//ConVars
	AutoExecConfig_SetFile("plugin.deaglemodes");
	
	gConVar_Chat_Prefix = AutoExecConfig_CreateConVar("sm_deaglemodes_chat_prefix", "[{green}TAG{default}]", "Chat Prefix");
	
	gConVar_DisableDeagle_Message = AutoExecConfig_CreateConVar("sm_deaglemodes_disable_deagle_message", "1", "Enable/Disable the Message on Chat when Deagle is Disable (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_EnableDeagle_Message = AutoExecConfig_CreateConVar("sm_deaglemodes_enable_deagle_message", "1", "Enable/Disable the Message on Chat when Deagle is Enable (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_OnOnlyHeadShot_Message = AutoExecConfig_CreateConVar("sm_deaglemodes_deagle_onlyhead_shot_message", "1", "Enable/Disable the Message on Chat when Deagle Only Head Shot is Enable (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_OffOnlyHeadShot_Message = AutoExecConfig_CreateConVar("sm_deaglemodes_deagle_full_all_body_message", "1", "Enable/Disable the Message on Chat when Deagle Only Head Shot is Disable (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_OnAntiSpam_Message = AutoExecConfig_CreateConVar("sm_deaglemodes_deagle_anti_spam_message", "1", "Enable/Disable the Message on Chat when Deagle Anti Spam Shot is Enable (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_OffAntiSpam_Message = AutoExecConfig_CreateConVar("sm_deaglemodes_deagle_spam_message", "1", "Enable/Disable the Message on Chat when Deagle Anti Spam Shot is Disable (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	
	gConVar_Start_Vote_Message = AutoExecConfig_CreateConVar("sm_deaglemodes_start_vote_message", "1", "Enable/Disable the Message on Chat when Player Start Vote (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_Votes_Resultes_Message = AutoExecConfig_CreateConVar("sm_deaglemodes_votes_results_message", "1", "Enable/Disable the Message on Chat with Votes Resultes (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	
	gConVar_CoolDown = AutoExecConfig_CreateConVar("sm_deaglemodes_cooldown", "5", "Cooldown Between Votes (Default - 5)", 0, true, 0.0, true, 100.0);
	
	gConVar_MapChange = AutoExecConfig_CreateConVar("sm_deaglemodes_mapchange", "1", "Save/Reset Current Deagle Modes When Map Change (1 - Reset | 0 - Save)", 0, true, 0.0, true, 1.0);
	
	gConVar_JoinMsg = AutoExecConfig_CreateConVar("sm_deaglemodes_join_message", "1", "Enable/Disable the Message when Players Join on Server (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_JoinStaffMsg = AutoExecConfig_CreateConVar("sm_deaglemodes_joinstaff_message", "1", "Enable/Disable the Message when Staff Join on Server (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	
	AutoExecConfig_ExecuteFile();
	AutoExecConfig_CleanFile();
	
	gConVar_Chat_Prefix.AddChangeHook(OnPrefixChange);
	
	//Admin Menu
	RegAdminCmd("sm_adeagle", Deagle, ADMFLAG_GENERIC);
	
	//Disable Deagle
	g_alRestrictedWeapons = new ArrayList(ByteCountToCells(NAME_LENGTH));
	
	RegAdminCmd("sm_deaglerestrictdeagle", Command_Restrict, ADMFLAG_GENERIC, "Restricts a weapon.");
	RegAdminCmd("sm_deagleunrestrictdeagle", Command_Unrestrict, ADMFLAG_GENERIC, "Unestricts a weapon.");
	
	if (g_bLateLoaded)
	{
		for (int client = 1; client < MaxClients; ++client)
		{
			if (IsClientInGame(client)) {
				OnClientPutInServer(client);
			}
		}
	}
	
	//GIVE DEAGLE
	HookEvent("round_start", OnRoundStart);
	
	RegAdminCmd("sm_givedeagle", GiveDeagle, ADMFLAG_ROOT);
	
	//DEAGLE VOTE FOR PLAYERS
	
	RegConsoleCmd("sm_deagle", deagle_modes);
	
	HookEvent("round_start", OnRoundStart1);
}

public void OnClientPutInServer(int client)
{
	//JoinMsg
	CreateTimer(5.2, JoinMsg, client);
	CreateTimer(5.4, JoinMsgStaff, client);
	
	//Disable Deagle
	SDKHook(client, SDKHook_WeaponEquip, Event_WeaponEquip);
}

//Prefix

public void SavePrefix()
{
	GetConVarString(gConVar_Chat_Prefix, g_ChatPrefix, sizeof(g_ChatPrefix));
}

public void OnConfigsExecuted()
{
	SavePrefix();
}

public void OnPrefixChange(ConVar cvar, char[] oldvalue, char[] newvalue)
{
	SavePrefix();
}

//JoinMsg

public Action JoinMsg(Handle timer, any client)
{
	if (gConVar_JoinMsg.BoolValue)
		CPrintToChat(client, "%s %t", g_ChatPrefix, "JoinMsg");
}


public Action JoinMsgStaff(Handle timer, any client)
{
	if (CheckCommandAccess(client, "sm_override_staff", ADMFLAG_GENERIC))
	{
		if (gConVar_JoinStaffMsg.BoolValue)
			CPrintToChat(client, "%s %t", g_ChatPrefix, "JoinMsgStaff");
	}
}

//////////////
// Deagle Menu
//////////////

public Action Deagle(int client, int args)
{
	ShowMenu(client);
}

void ShowMenu(int client)
{
	char DeagleMenu1[128];
	char DisableDeagleMenu1[128];
	char EnableDeagleMenu1[128];
	
	char OnlyHeadShotMenu1[128];
	char OffOnlyHeadMenu1[128];
	char OnOnlyHeadMenu1[128];
	
	char AntiSpamMenu1[128];
	char OnAntiSpamMenu1[128];
	char OffAntiSpamMenu1[128];
	
	Menu menu = new Menu(Menu_Handler);
	menu.SetTitle("%t", "DeagleModesMenuTitle");
	
	Format(DeagleMenu1, sizeof(DeagleMenu1), "%t", "DeagleMenu");
	menu.AddItem("space1", DeagleMenu1, ITEMDRAW_DISABLED);
	if (!Deagle1)
	{
		Format(EnableDeagleMenu1, sizeof(EnableDeagleMenu1), "%t", "EnableDeagleMenu");
		menu.AddItem("1", EnableDeagleMenu1);
	}
	else
	{
		Format(DisableDeagleMenu1, sizeof(DisableDeagleMenu1), "%t", "DisableDeagleMenu");
		menu.AddItem("2", DisableDeagleMenu1);
	}
	
	if (LibraryExists("spirt_deaglehs")) //WITH DEAGLE ONLY HS PLUGIN
	{
		Format(OnlyHeadShotMenu1, sizeof(OnlyHeadShotMenu1), "%t", "OnlyHeadShotMenu");
		menu.AddItem("space2", OnlyHeadShotMenu1, ITEMDRAW_DISABLED);
		if (!OnlyHeadShot)
		{
			Format(OnOnlyHeadMenu1, sizeof(OnOnlyHeadMenu1), "%t", "OnOnlyHeadMenu");
			menu.AddItem("3", OnOnlyHeadMenu1);
		}
		else
		{
			Format(OffOnlyHeadMenu1, sizeof(OffOnlyHeadMenu1), "%t", "OffOnlyHeadMenu");
			menu.AddItem("4", OffOnlyHeadMenu1);
		}
	}
	
	if (LibraryExists("anti-deagle-spam")) //WITH ANTI DEAGLE SPAM PLUGIN
	{
		Format(AntiSpamMenu1, sizeof(AntiSpamMenu1), "%t", "AntiSpamMenu");
		menu.AddItem("space3", AntiSpamMenu1, ITEMDRAW_DISABLED);
		if (!AntiSpam)
		{
			Format(OnAntiSpamMenu1, sizeof(OnAntiSpamMenu1), "%t", "OnAntiSpamMenu");
			menu.AddItem("5", OnAntiSpamMenu1);
		}
		else
		{
			Format(OffAntiSpamMenu1, sizeof(OffAntiSpamMenu1), "%t", "OffAntiSpamMenu");
			menu.AddItem("6", OffAntiSpamMenu1);
		}
	}
	else
		LogMessage("LibraryExists anti_deagle_spam - NAO");
	
	menu.ExitButton = true;
	menu.Display(client, MENU_TIME_FOREVER);
}

public int Menu_Handler(Menu menu, MenuAction action, int client, int args)
{
	if (action == MenuAction_Select)
	{
		char selectedItem[200];
		menu.GetItem(args, selectedItem, sizeof(selectedItem));
		if (StrEqual(selectedItem, "1"))
		{
			Deagle1 = true;
			
			ServerCommand("sm_deagleunrestrictdeagle deagle");
			
			ServerCommand("sm_givedeagle");
			
			if (gConVar_EnableDeagle_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "EnableDeagle");
		}
		if (StrEqual(selectedItem, "2"))
		{
			Deagle1 = false;
			
			ServerCommand("sm_deaglerestrictdeagle deagle");
			
			if (gConVar_DisableDeagle_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "DisableDeagle");
		}
		if (StrEqual(selectedItem, "3"))
		{
			OnlyHeadShot = true;
			
			ServerCommand("sm plugins load spirt_deaglehs");
			
			if (gConVar_OnOnlyHeadShot_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "OnOnlyHead");
		}
		if (StrEqual(selectedItem, "4"))
		{
			OnlyHeadShot = false;
			
			ServerCommand("sm plugins unload spirt_deaglehs");
			
			if (gConVar_OffOnlyHeadShot_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "OffOnlyHead");
		}
		if (StrEqual(selectedItem, "5"))
		{
			AntiSpam = true;
			
			ServerCommand("sm plugins load anti-deagle-spam");
			
			if (gConVar_OnAntiSpam_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "OnAntiSpam");
		}
		if (StrEqual(selectedItem, "6"))
		{
			AntiSpam = false;
			
			ServerCommand("sm plugins unload anti-deagle-spam");
			
			if (gConVar_OffAntiSpam_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "OffAntiSpam");
		}
	}
	else if (action == MenuAction_End)
	{
		delete menu;
	}
}

//Disable Deagle

public Action Event_WeaponEquip(int client, int weapon)
{
	char weaponClass[NAME_LENGTH];
	GetEdictClassname(weapon, weaponClass, sizeof(weaponClass));
	
	StripWeaponPrefix(weaponClass, sizeof(weaponClass));
	
	if (g_alRestrictedWeapons.FindString(weaponClass) != -1)
	{
		AcceptEntityInput(weapon, "kill");
		return Plugin_Handled;
	}
	return Plugin_Continue;
}

public Action Command_Restrict(int client, int args)
{
	char weaponAlias[NAME_LENGTH];
	GetCmdArg(1, weaponAlias, sizeof(weaponAlias));
	
	StripWeaponPrefix(weaponAlias, sizeof(weaponAlias));
	
	LowerCaseString(weaponAlias);
	
	if (g_alRestrictedWeapons.FindString(weaponAlias) != -1)
	{
		return Plugin_Handled;
	}
	
	g_alRestrictedWeapons.PushString(weaponAlias);
	
	RemoveWeaponFromAllPlayer(weaponAlias);
	
	return Plugin_Handled;
}

public Action Command_Unrestrict(int client, int args)
{
	char weaponAlias[NAME_LENGTH];
	GetCmdArg(1, weaponAlias, sizeof(weaponAlias));
	
	StripWeaponPrefix(weaponAlias, sizeof(weaponAlias));
	
	LowerCaseString(weaponAlias);
	
	int index = g_alRestrictedWeapons.FindString(weaponAlias);
	if (index == -1)
	{
		return Plugin_Handled;
	}
	
	g_alRestrictedWeapons.Erase(index);
	
	return Plugin_Handled;
}

void RemoveWeaponFromAllPlayer(const char[] weaponAlias)
{
	char weaponClass[NAME_LENGTH];
	Format(weaponClass, sizeof(weaponClass), "weapon_%s", weaponAlias);
	
	for (int client = 1; client < MaxClients; ++client)
	{
		if (!IsClientInGame(client))
		{
			continue;
		}
		
		for (int slot = CS_SLOT_PRIMARY; slot <= CS_SLOT_C4; ++slot)
		{
			
			int weapon = GetPlayerWeaponSlot(client, slot);
			
			if (weapon == -1)
			{
				continue;
			}
			
			char entityClass[NAME_LENGTH];
			GetEdictClassname(weapon, entityClass, sizeof(entityClass));
			
			if (StrEqual(weaponClass, entityClass, true))
			{
				if (RemovePlayerItem(client, weapon))
				{
					AcceptEntityInput(weapon, "kill");
				}
				break;
			}
		}
	}
}

void StripWeaponPrefix(char[] weapon, int size)
{
	ReplaceString(weapon, size, "weapon_", "", false);
}

void LowerCaseString(char[] s)
{
	for (int i = 0; ; ++i)
	{
		if (s[i] == '\0')
		{
			break;
		}
		
		if (IsCharUpper(s[i]))
		{
			s[i] = CharToLower(s[i]);
		}
	}
}


//GIVE DEAGLE

public Action OnRoundStart(Event event, const char[] name, bool dontBroadcast)
{
	for (int i = 1; i <= MaxClients; i++)
	{
		if (!IsClientInGame(i))continue;
		int Secondary = GetPlayerWeaponSlot(i, CS_SLOT_SECONDARY);
		
		if (Secondary != -1)
		{
			if (!StrEqual(name, "weapon_deagle"))
			{
				RemovePlayerItem(i, Secondary);
				GivePlayerItem(i, "weapon_deagle");
			}
		}
		else
		{
			GivePlayerItem(i, "weapon_deagle");
		}
	}
}

public Action GiveDeagle(int client, int args)
{
	for (int i = 1; i <= MaxClients; i++)
	{
		if (!IsClientInGame(i))continue;
		int Secondary = GetPlayerWeaponSlot(i, CS_SLOT_SECONDARY);
		char name[128];
		
		if (Secondary != -1)
		{
			if (!StrEqual(name, "weapon_deagle"))
			{
				RemovePlayerItem(i, Secondary);
				GivePlayerItem(i, "weapon_deagle");
			}
		}
		else
		{
			GivePlayerItem(i, "weapon_deagle");
		}
	}
}

//ISVALIDCLIENT

stock bool IsValidClient(int client)
{
	return (1 <= client <= MaxClients && IsClientInGame(client) && !IsClientSourceTV(client));
}

///////////////////////////
//DEAGLE VOTE FOR PLAYERS//
//DEAGLE VOTE FOR PLAYERS//
//DEAGLE VOTE FOR PLAYERS//
//DEAGLE VOTE FOR PLAYERS//
//DEAGLE VOTE FOR PLAYERS//
//DEAGLE VOTE FOR PLAYERS//
//DEAGLE VOTE FOR PLAYERS//
//DEAGLE VOTE FOR PLAYERS//
//DEAGLE VOTE FOR PLAYERS//
//DEAGLE VOTE FOR PLAYERS//
//DEAGLE VOTE FOR PLAYERS//
//DEAGLE VOTE FOR PLAYERS//
///////////////////////////

//MODE 1 - ENABLE DEAGLE 
//MODE 2 - DISABLE DEAGLE 

//MODE 3 - ENABLE ONLYHS DEAGLE 
//MODE 4 - DISABLE ONLYHS DEAGLE 

//MODE 5 - ENABLE ANTISPAM DEAGLE 
//MODE 6 - DISABLE ANTISPAM DEAGLE 

int Mode;
int Cooldown;

int yes;
int no;

bool ModeVoted = false;

bool ShowMenuDeagleVotes = false;

public void OnMapStart()
{
	if (gConVar_MapChange.BoolValue)
	{
		OnlyHeadShot = true;
		AntiSpam = true;
		Deagle1 = true;
		
		ServerCommand("sm_deagleunrestrictdeagle deagle");
		ServerCommand("sm plugins load spirt_deaglehs");
		ServerCommand("sm plugins load anti-deagle-spam");
	}
	
	
	ModeVoted = false;
	
	yes = 0;
	no = 0;
	
	Cooldown = 2;
}

public Action deagle_modes(int client, int args)
{
	OpenModeMenu(client);
}

void OpenModeMenu(int client)
{
	Menu menu = new Menu(mMenu);
	if (Cooldown == 0 && !ShowMenuDeagleVotes)
	{
		menu.SetTitle("%t", "VoteDeagleMenuTitle");
	}
	else
	{
		menu.SetTitle("%t", "VoteDeagleMenuDelayTitle", Cooldown);
	}
	if (Cooldown == 0 && !ShowMenuDeagleVotes)
	{
		char DeagleMenu1[128];
		char DisableDeagleMenu1[128];
		char EnableDeagleMenu1[128];
		
		char OnlyHeadShotMenu1[128];
		char OffOnlyHeadMenu1[128];
		char OnOnlyHeadMenu1[128];
		
		char AntiSpamMenu1[128];
		char OnAntiSpamMenu1[128];
		char OffAntiSpamMenu1[128];
		
		Format(DeagleMenu1, sizeof(DeagleMenu1), "%t", "DeagleMenu");
		menu.AddItem("space1", DeagleMenu1, ITEMDRAW_DISABLED);
		if (!Deagle1)
		{
			Format(EnableDeagleMenu1, sizeof(EnableDeagleMenu1), "%t", "EnableDeagleMenu");
			menu.AddItem("deagleon", EnableDeagleMenu1);
		}
		else
		{
			Format(DisableDeagleMenu1, sizeof(DisableDeagleMenu1), "%t", "DisableDeagleMenu");
			menu.AddItem("deagleoff", DisableDeagleMenu1);
		}
		
		if (LibraryExists("spirt_deaglehs")) //WITH DEAGLE ONLY HS PLUGIN
		{
			Format(OnlyHeadShotMenu1, sizeof(OnlyHeadShotMenu1), "%t", "OnlyHeadShotMenu");
			menu.AddItem("space2", OnlyHeadShotMenu1, ITEMDRAW_DISABLED);
			if (!OnlyHeadShot)
			{
				Format(OnOnlyHeadMenu1, sizeof(OnOnlyHeadMenu1), "%t", "OnOnlyHeadMenu");
				menu.AddItem("onlyhson", OnOnlyHeadMenu1);
			}
			else
			{
				Format(OffOnlyHeadMenu1, sizeof(OffOnlyHeadMenu1), "%t", "OffOnlyHeadMenu");
				menu.AddItem("onlyhsoff", OffOnlyHeadMenu1);
			}
		}
		
		if (LibraryExists("anti-deagle-spam")) //WITH ANTI DEAGLE SPAM PLUGIN
		{
			Format(AntiSpamMenu1, sizeof(AntiSpamMenu1), "%t", "AntiSpamMenu");
			menu.AddItem("space3", AntiSpamMenu1, ITEMDRAW_DISABLED);
			if (!AntiSpam)
			{
				Format(OnAntiSpamMenu1, sizeof(OnAntiSpamMenu1), "%t", "OnAntiSpamMenu");
				menu.AddItem("antispamon", OnAntiSpamMenu1);
			}
			else
			{
				Format(OffAntiSpamMenu1, sizeof(OffAntiSpamMenu1), "%t", "OffAntiSpamMenu");
				menu.AddItem("antispamoff", OffAntiSpamMenu1);
			}
		}
	}
	else
	{
		char DeagleMenu1[128];
		char DisableDeagleMenu1[128];
		char EnableDeagleMenu1[128];
		
		char OnlyHeadShotMenu1[128];
		char OffOnlyHeadMenu1[128];
		char OnOnlyHeadMenu1[128];
		
		char AntiSpamMenu1[128];
		char OnAntiSpamMenu1[128];
		char OffAntiSpamMenu1[128];
		
		Format(DeagleMenu1, sizeof(DeagleMenu1), "%t", "DeagleMenu");
		menu.AddItem("space1", DeagleMenu1, ITEMDRAW_DISABLED);
		if (!Deagle1)
		{
			Format(EnableDeagleMenu1, sizeof(EnableDeagleMenu1), "%t", "EnableDeagleMenu");
			menu.AddItem("deagleon", EnableDeagleMenu1, ITEMDRAW_DISABLED);
		}
		else
		{
			Format(DisableDeagleMenu1, sizeof(DisableDeagleMenu1), "%t", "DisableDeagleMenu");
			menu.AddItem("deagleoff", DisableDeagleMenu1, ITEMDRAW_DISABLED);
		}
		
		if (LibraryExists("spirt_deaglehs")) //WITH DEAGLE ONLY HS PLUGIN
		{
			Format(OnlyHeadShotMenu1, sizeof(OnlyHeadShotMenu1), "%t", "OnlyHeadShotMenu");
			menu.AddItem("space2", OnlyHeadShotMenu1, ITEMDRAW_DISABLED);
			if (!OnlyHeadShot)
			{
				Format(OnOnlyHeadMenu1, sizeof(OnOnlyHeadMenu1), "%t", "OnOnlyHeadMenu");
				menu.AddItem("onlyhson", OnOnlyHeadMenu1, ITEMDRAW_DISABLED);
			}
			else
			{
				Format(OffOnlyHeadMenu1, sizeof(OffOnlyHeadMenu1), "%t", "OffOnlyHeadMenu");
				menu.AddItem("onlyhsoff", OffOnlyHeadMenu1, ITEMDRAW_DISABLED);
			}
		}
		
		if (LibraryExists("anti-deagle-spam")) //WITH ANTI DEAGLE SPAM PLUGIN
		{
			Format(AntiSpamMenu1, sizeof(AntiSpamMenu1), "%t", "AntiSpamMenu");
			menu.AddItem("space3", AntiSpamMenu1, ITEMDRAW_DISABLED);
			if (!AntiSpam)
			{
				Format(OnAntiSpamMenu1, sizeof(OnAntiSpamMenu1), "%t", "OnAntiSpamMenu");
				menu.AddItem("antispamon", OnAntiSpamMenu1, ITEMDRAW_DISABLED);
			}
			else
			{
				Format(OffAntiSpamMenu1, sizeof(OffAntiSpamMenu1), "%t", "OffAntiSpamMenu");
				menu.AddItem("antispamoff", OffAntiSpamMenu1, ITEMDRAW_DISABLED);
			}
		}
	}
	menu.Display(client, MENU_TIME_FOREVER);
}

public int mMenu(Menu menu, MenuAction action, int client, int param2)
{
	switch (action)
	{
		case MenuAction_Select:
		{
			char name[128];
			GetClientName(client, name, sizeof(name));
			
			char szItem[32];
			menu.GetItem(param2, szItem, sizeof(szItem));
			
			
			if (StrEqual(szItem, "deagleon"))
			{
				Mode = -1;
				
				if (gConVar_Start_Vote_Message.BoolValue)
					CPrintToChatAll("%s %t", g_ChatPrefix, "StartVoteDeagleOn", name);
				
				StartVotingMenu();
			}
			if (StrEqual(szItem, "deagleoff"))
			{
				Mode = -2;
				
				if (gConVar_Start_Vote_Message.BoolValue)
					CPrintToChatAll("%s %t", g_ChatPrefix, "StartVoteDeagleOff", name);
				
				StartVotingMenu();
			}
			if (StrEqual(szItem, "onlyhson"))
			{
				Mode = -3;
				
				if (gConVar_Start_Vote_Message.BoolValue)
					CPrintToChatAll("%s %t", g_ChatPrefix, "StartVoteOnlyHsOn", name);
				
				StartVotingMenu();
			}
			if (StrEqual(szItem, "onlyhsoff"))
			{
				Mode = -4;
				
				if (gConVar_Start_Vote_Message.BoolValue)
					CPrintToChatAll("%s %t", g_ChatPrefix, "StartVoteOnlyHsOff", name);
				
				StartVotingMenu();
			}
			if (StrEqual(szItem, "antispamon"))
			{
				Mode = -5;
				
				if (gConVar_Start_Vote_Message.BoolValue)
					CPrintToChatAll("%s %t", g_ChatPrefix, "StartVoteAntiSpamOn", name);
				
				StartVotingMenu();
			}
			if (StrEqual(szItem, "antispamoff"))
			{
				Mode = -6;
				
				if (gConVar_Start_Vote_Message.BoolValue)
					CPrintToChatAll("%s %t", g_ChatPrefix, "StartVoteAntiSpamOff", name);
				
				StartVotingMenu();
			}
		}
		case MenuAction_End:
		{
			delete menu;
		}
	}
}

void StartVotingMenu()
{
	for (int i = 1; i <= MaxClients; i++)
	{
		if (!IsClientInGame(i))continue;
		Menu menu = new Menu(mVotingMenu);
		
		if (Mode == -1)
		{
			menu.SetTitle("%t", "VoteDeagleOn");
		}
		if (Mode == -2)
		{
			menu.SetTitle("%t", "VoteDeagleOff");
		}
		if (Mode == -3)
		{
			menu.SetTitle("%t", "VoteOnlyHsOn");
		}
		if (Mode == -4)
		{
			menu.SetTitle("%t", "VoteOnlyHsOff");
		}
		if (Mode == -5)
		{
			menu.SetTitle("%t", "VoteAntiSpamOn");
		}
		if (Mode == -6)
		{
			menu.SetTitle("%t", "VoteAntiSpamOff");
		}
		menu.AddItem("yes", "Sim");
		menu.AddItem("no", "Não");
		
		menu.Display(i, 10);
	}
	
	ShowMenuDeagleVotes = true;
	
	CreateTimer(15.0, tTimerCountVotes);
}

public int mVotingMenu(Menu menu, MenuAction action, int param1, int param2)
{
	switch (action)
	{
		case MenuAction_Select:
		{
			char szItem[32];
			menu.GetItem(param2, szItem, sizeof(szItem));
			if (StrEqual(szItem, "yes"))
			{
				if (CheckCommandAccess(param1, "", ADMFLAG_CUSTOM1))
				{
					yes++;
				}
				yes++;
			}
			else
			{
				if (CheckCommandAccess(param1, "", ADMFLAG_CUSTOM1))
				{
					no++;
				}
				no++;
			}
		}
	}
}

public Action tTimerCountVotes(Handle timer)
{
	if (yes > no)
	{
		if (Mode == -1 || Mode == -2 || Mode == -3 || Mode == -4 || Mode == -5 || Mode == -6)
		{
			ModeVoted = true;
		}
		
		if (gConVar_Votes_Resultes_Message.BoolValue)
			CPrintToChatAll("%s %t", g_ChatPrefix, "VoteYes");
	}
	else
	{
		if (gConVar_Votes_Resultes_Message.BoolValue)
			CPrintToChatAll("%s %t", g_ChatPrefix, "VoteNo");
		
		Cooldown = gConVar_CoolDown.IntValue;
		
		ModeVoted = false;
		
		ShowMenuDeagleVotes = false;
	}
	yes = 0;
	no = 0;
}

public Action OnRoundStart1(Event event, const char[] name, bool dontBroadcast)
{
	if (Cooldown > 0)
	{
		Cooldown--;
	}
	if (ModeVoted)
	{
		Cooldown = gConVar_CoolDown.IntValue;
		
		ModeVoted = false;
		
		ShowMenuDeagleVotes = false;
		
		if (Mode == -1)
		{
			Deagle1 = true;
			
			ServerCommand("sm_deagleunrestrictdeagle deagle");
			
			if (gConVar_EnableDeagle_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "EnableDeagle");
			
			ServerCommand("sm_givedeagle");
			
		}
		if (Mode == -2)
		{
			Deagle1 = false;
			
			if (gConVar_DisableDeagle_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "DisableDeagle");
			
			ServerCommand("sm_deaglerestrictdeagle deagle");
			
		}
		if (Mode == -3)
		{
			OnlyHeadShot = true;
			
			if (gConVar_OnOnlyHeadShot_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "OnOnlyHead");
			
			ServerCommand("sm plugins load spirt_deaglehs");
			
		}
		if (Mode == -4)
		{
			OnlyHeadShot = false;
			
			if (gConVar_OffOnlyHeadShot_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "OffOnlyHead");
			
			ServerCommand("sm plugins unload spirt_deaglehs");
			
		}
		if (Mode == -5)
		{
			AntiSpam = true;
			
			if (gConVar_OnAntiSpam_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "OnAntiSpam");
			
			ServerCommand("sm plugins load anti-deagle-spam");
			
		}
		if (Mode == -6)
		{
			AntiSpam = false;
			
			if (gConVar_OffAntiSpam_Message.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "OffAntiSpam");
			
			ServerCommand("sm plugins unload anti-deagle-spam");
			
		}
	}
}

//ADMIN DEAGLE - ADMIN MENU

public void OnAllPluginsLoaded()
{
	Handle topmenu;
	if (LibraryExists("adminmenu") && ((topmenu = GetAdminTopMenu()) != null))
		OnAdminMenuReady(topmenu);
}

public void OnAdminMenuReady(Handle topmenu)
{
	if (topmenu == hAdminMenu)
		return;
	
	hAdminMenu = topmenu;
	CreateTimer(1.0, Timer_AttachAdminMenu);
}

public Action Timer_AttachAdminMenu(Handle timer)
{
	TopMenuObject menu_category = AddToTopMenu(hAdminMenu, "admindeagle", TopMenuObject_Category, Handle_Category, INVALID_TOPMENUOBJECT, "admindeagle", ADMFLAG_GENERIC);
	if (menu_category == INVALID_TOPMENUOBJECT)
		return;
	
	AddToTopMenu(hAdminMenu, "sm_adeagle", TopMenuObject_Item, AdminMenu_DeagleModesAdmin, menu_category, "sm_adeagle", ADMFLAG_GENERIC);
}

public void Handle_Category(TopMenu topmenu, TopMenuAction action, TopMenuObject topobj_id, int param, char[] buffer, int maxlength)
{
	if (action == TopMenuAction_DisplayTitle)
		Format(buffer, maxlength, "%T", "Admin Deagle Title in Admin", param);
	else if (action == TopMenuAction_DisplayOption)
		Format(buffer, maxlength, "%T", "Admin Deagle Title in Admin", param);
}

public void AdminMenu_DeagleModesAdmin(TopMenu topmenu, TopMenuAction action, TopMenuObject topobj_id, int client, char[] buffer, int maxlength)
{
	if (action == TopMenuAction_DisplayOption)
		Format(buffer, maxlength, "%T", "Admin Deagle Buttom in Admin", client);
	else if (action == TopMenuAction_SelectOption)
		ShowMenu(client);
} 